## libad9361 0.1

=== CMakeLists.txt ===
# Copyright (C) 2015 Analog Devices, Inc.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

cmake_minimum_required(VERSION 2.8.7)
project(ad9361 C)

set(LIBAD9361_VERSION_MAJOR 0)
set(LIBAD9361_VERSION_MINOR 1)
set(LIBAD9361_VERSION ${LIBAD9361_VERSION_MAJOR}.${LIBAD9361_VERSION_MINOR})

set(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries")

set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib"
	CACHE PATH "Installation directory for libraries")
mark_as_advanced(INSTALL_LIB_DIR)

include(FindPkgConfig REQUIRED)
pkg_check_modules(LIBIIO REQUIRED libiio)

set(LIBAD9361_HEADERS ad9361.h)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${LIBIIO_INCLUDEDIR})
add_library(ad9361 ad9361_multichip_sync.c ${LIBAD9361_HEADERS})
set_target_properties(ad9361 PROPERTIES VERSION ${LIBAD9361_VERSION} SOVERSION ${LIBAD9361_VERSION_MAJOR} FRAMEWORK TRUE PUBLIC_HEADER "${LIBAD9361_HEADERS}")
target_link_libraries(ad9361 LINK_PRIVATE ${LIBIIO_LIBS})

set(LIBAD9361_PC ${CMAKE_CURRENT_BINARY_DIR}/libad9361.pc)
configure_file(libad9361.pc.cmakein ${LIBAD9361_PC} @ONLY)
install(FILES ${LIBAD9361_PC} DESTINATION ${INSTALL_LIB_DIR}/pkgconfig)

if(NOT SKIP_INSTALL_ALL)
	install(TARGETS ad9361
		ARCHIVE DESTINATION lib
		LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
		RUNTIME DESTINATION bin
		FRAMEWORK DESTINATION lib
		PUBLIC_HEADER DESTINATION include)
endif()

=== debian/changelog ===
libad9361 (0.1-4) unstable; urgency=medium

  * Adopt package, update Vcs

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 05 Sep 2017 20:41:48 -0400

libad9361 (0.1-3) unstable; urgency=medium

  * update to 6027674

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 04 Sep 2017 15:51:20 -0400

libad9361 (0.1-2) unstable; urgency=medium

  * update to faa8556

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 28 Apr 2016 00:12:24 -0400

libad9361 (0.1-1) unstable; urgency=medium

  * Initial upload to Debian (closes: #814039)
  * Sponsor libad9361 for Paul Cercueil
  * Update to 3.0 (quilt)
  * Add no-op watch file

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 07 Feb 2016 16:23:10 -0500

libad9361 (0.1) unstable; urgency=low

  * Initial release.

 -- Paul Cercueil <paul.cercueil@analog.com>  Wed, 29 Jul 2015 14:46:52 +0200

=== debian/control ===
Source: libad9361
Section: libs
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9),
               libiio-dev,
               pkg-config
Standards-Version: 4.1.0
Homepage: https://github.com/analogdevicesinc/libad9361-iio
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libad9361.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libad9361.git

Package: libad9361-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library of functions specific to the Analog Devices AD9361
 This library contains a few functions useful to configure and use the
 Analog Devices AD9361 Agile Transceiver.
 .
 The device combines an RF front end with a flexible mixed-signal
 baseband section and integrated frequency synthesizers. The AD9361
 operates in the 70 MHz to 6.0 GHz range, covering most licensed and
 unlicensed bands. Channel bandwidths from less than 200 kHz to 56 MHz
 are supported. This library provides hardware support for Software
 Defined Radio aplications.
 .
 Using libiio allows use with both locally attached devices and
 hardware available over a network link.

Package: libad9361-dev
Section: libdevel
Architecture: any
Depends: libad9361-0 (= ${binary:Version}), ${misc:Depends}
Description: Development files specific to the Analog Devices AD9361
 This library contains a few functions useful to configure and use the
 Analog Devices AD9361 Agile Transceiver.
 .
 The device combines an RF front end with a flexible mixed-signal
 baseband section and integrated frequency synthesizers. The AD9361
 operates in the 70 MHz to 6.0 GHz range, covering most licensed and
 unlicensed bands. Channel bandwidths from less than 200 kHz to 56 MHz
 are supported. This library provides hardware support for Software
 Defined Radio aplications.
 .
 Using libiio allows use with both locally attached devices and
 hardware available over a network link.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DINSTALL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_compress:
	dh_compress -X.c -X.C

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/v$1.tar.gz/ \
  https://github.com/analogdevicesinc/libad9361-iio/tags .*/v(\d\S*)\.tar\.gz

## libad9361 0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,24 +14,87 @@
 project(ad9361 C)
 
 set(LIBAD9361_VERSION_MAJOR 0)
-set(LIBAD9361_VERSION_MINOR 1)
-set(LIBAD9361_VERSION ${LIBAD9361_VERSION_MAJOR}.${LIBAD9361_VERSION_MINOR})
+set(LIBAD9361_VERSION_MINOR 2)
+set(VERSION ${LIBAD9361_VERSION_MAJOR}.${LIBAD9361_VERSION_MINOR})
+
+if (WIN32)
+	string(TIMESTAMP BUILD_YEAR "%Y")
+endif()
+
+if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+	option(OSX_PACKAGE "Create a OSX package" ON)
+	set(CMAKE_MACOSX_RPATH ON)
+	set(SKIP_INSTALL_ALL ${OSX_PACKAGE})
+endif()
+
+include(FindGit OPTIONAL)
+if (GIT_FOUND)
+	execute_process(
+		COMMAND ${GIT_EXECUTABLE} rev-parse --show-toplevel
+		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+		OUTPUT_VARIABLE LIBAD9361_GIT_REPO
+		OUTPUT_STRIP_TRAILING_WHITESPACE
+		ERROR_QUIET
+	)
+
+if ("${LIBAD9361_GIT_REPO}" STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")
+		execute_process(
+			COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
+			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+			OUTPUT_VARIABLE LIBAD9361_VERSION_GIT
+			OUTPUT_STRIP_TRAILING_WHITESPACE
+		)
+	endif()
+endif()
+
+if (NOT LIBAD9361_VERSION_GIT)
+	set(LIBAD9361_VERSION_GIT v${VERSION})
+endif()
 
 set(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries")
+
+if (NOT WIN32)
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
+endif()
+
+add_definitions(-D_POSIX_C_SOURCE=199309L -DLIBAD9361_EXPORTS=1)
 
 set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib"
 	CACHE PATH "Installation directory for libraries")
 mark_as_advanced(INSTALL_LIB_DIR)
 
-include(FindPkgConfig REQUIRED)
-pkg_check_modules(LIBIIO REQUIRED libiio)
+find_library(LIBIIO_LIBRARIES iio)
+find_path(LIBIIO_INCLUDEDIR iio.h)
 
 set(LIBAD9361_HEADERS ad9361.h)
 
+file(GLOB_RECURSE FD_SRC_FILES ${CMAKE_CURRENT_SOURCE_DIR}/filterdesigner/*.c)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${LIBIIO_INCLUDEDIR})
-add_library(ad9361 ad9361_multichip_sync.c ${LIBAD9361_HEADERS})
-set_target_properties(ad9361 PROPERTIES VERSION ${LIBAD9361_VERSION} SOVERSION ${LIBAD9361_VERSION_MAJOR} FRAMEWORK TRUE PUBLIC_HEADER "${LIBAD9361_HEADERS}")
-target_link_libraries(ad9361 LINK_PRIVATE ${LIBIIO_LIBS})
+add_library(ad9361 ad9361_multichip_sync.c
+            ad9361_baseband_auto_rate.c
+            ad9361_design_taps.c
+            ad9361_calculate_rf_clock_chain.c
+            ad9361_fmcomms5_phase_sync.c
+            ${FD_SRC_FILES}
+            ${LIBAD9361_HEADERS})
+enable_testing()
+add_subdirectory(test)
+set_target_properties(ad9361 PROPERTIES
+	VERSION ${VERSION}
+	SOVERSION ${LIBAD9361_VERSION_MAJOR}
+	FRAMEWORK TRUE
+	PUBLIC_HEADER ${LIBAD9361_HEADERS}
+	C_STANDARD 99
+	C_STANDARD_REQUIRED ON
+	C_EXTENSIONS OFF
+)
+target_link_libraries(ad9361 LINK_PRIVATE ${LIBIIO_LIBRARIES})
+
+if (MSVC)
+	set_target_properties(ad9361 PROPERTIES OUTPUT_NAME libad9361)
+endif()
+
+configure_file(libad9361-iio.iss.cmakein ${CMAKE_CURRENT_BINARY_DIR}/libad9361-iio.iss @ONLY)
 
 set(LIBAD9361_PC ${CMAKE_CURRENT_BINARY_DIR}/libad9361.pc)
 configure_file(libad9361.pc.cmakein ${LIBAD9361_PC} @ONLY)
@@ -45,3 +108,84 @@
 		FRAMEWORK DESTINATION lib
 		PUBLIC_HEADER DESTINATION include)
 endif()
+
+set(CMAKE_INSTALL_DOCDIR "" CACHE PATH "documentation root (DATAROOTDIR/doc/${PROJECT_NAME}${LIBAD9361_VERSION_MAJOR}-doc)")
+include(GNUInstallDirs)
+set(CMAKE_INSTALL_DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/${PROJECT_NAME}${LIBAD9361_VERSION_MAJOR}-doc")
+
+find_package(Doxygen)
+if(DOXYGEN_FOUND)
+	option(WITH_DOC "Generate documentation with Doxygen" ON)
+
+	if (WITH_DOC)
+		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
+		set(HTML_DEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/html)
+		file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/doc DESTINATION ${HTML_DEST_DIR})
+
+		add_custom_command(TARGET ad9361 POST_BUILD
+			COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
+			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+			COMMENT "Generating API documentation with Doxygen" VERBATIM
+			)
+
+		if(NOT SKIP_INSTALL_ALL)
+			install(DIRECTORY ${HTML_DEST_DIR} DESTINATION ${CMAKE_INSTALL_DOCDIR})
+		endif()
+	endif()
+else()
+	message(STATUS "Doxygen not found, API documentation won't be generated")
+endif()
+
+add_subdirectory(bindings/matlab)
+
+# Create an installer if compiling for OSX
+if(OSX_PACKAGE)
+	set(LIBAD9361_PKG ${CMAKE_CURRENT_BINARY_DIR}/libad9361-${VERSION}.pkg)
+	set(LIBAD9361_TEMP_PKG ${CMAKE_CURRENT_BINARY_DIR}/libad9361-${VERSION}-temp.pkg)
+	set(LIBAD9361_DISTRIBUTION_XML ${CMAKE_CURRENT_BINARY_DIR}/Distribution.xml)
+	set(LIBAD9361_FRAMEWORK_DIR ${CMAKE_CURRENT_BINARY_DIR}/ad9361.framework)
+	configure_file(Distribution.xml.cmakein ${LIBAD9361_DISTRIBUTION_XML} @ONLY)
+
+	find_program(PKGBUILD_EXECUTABLE
+		NAMES pkgbuild
+		DOC "OSX Package builder (pkgbuild)")
+	mark_as_advanced(PKGBUILD_EXECUTABLE)
+
+	find_program(PRODUCTBUILD_EXECUTABLE
+		NAMES productbuild
+		DOC "OSX Package builder (productbuild)")
+	mark_as_advanced(PRODUCTBUILD_EXECUTABLE)
+
+	add_custom_command(OUTPUT ${LIBAD9361_PKG}
+		COMMAND ${PKGBUILD_EXECUTABLE}
+			--component ${LIBAD9361_FRAMEWORK_DIR}
+			--identifier com.adi.ad9361 --version ${VERSION}
+			--install-location /Library/Frameworks ${LIBAD9361_TEMP_PKG}
+		COMMAND ${PRODUCTBUILD_EXECUTABLE}
+			--distribution ${LIBAD9361_DISTRIBUTION_XML} ${LIBAD9361_PKG}
+		COMMAND ${CMAKE_COMMAND} -E remove ${LIBAD9361_TEMP_PKG}
+		DEPENDS ad9361 ${LIBAD9361_DISTRIBUTION_XML}
+	)
+
+	if (PKGBUILD_EXECUTABLE AND PRODUCTBUILD_EXECUTABLE)
+		add_custom_target(libad9361-pkg ALL DEPENDS ${LIBAD9361_PKG})
+
+		install(CODE "execute_process(COMMAND /usr/sbin/installer -pkg ${LIBAD9361_PKG} -target /)")
+	else()
+		message(WARNING "Missing pkgbuild or productbuild: OSX installer won't be created.")
+	endif()
+else()
+	# Support creating some basic binpkgs via `make package`.
+	# Disabled if OSX_PACKAGE is enabled, as tarballs would
+	#   end up empty otherwise.
+	option(ENABLE_PACKAGING "Create .deb/.rpm or .tar.gz packages via 'make package'" ON)
+
+	if(ENABLE_PACKAGING)
+		if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+			include(cmake/DarwinPackaging.cmake)
+		endif()
+		if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+			include(cmake/LinuxPackaging.cmake)
+		endif()
+	endif()
+endif()

=== bindings/matlab/CMakeLists.txt ===
install (FILES ad9361-wrapper.h DESTINATION include)

=== debian/changelog ===
libad9361 (0.2-1) unstable; urgency=medium

  * New upstream release
  * update to v0.2-8-ge7bb5cd
  * make the documentation reproducible (Closes: #922520)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 14 Aug 2019 21:13:06 -0400

libad9361 (0.1-5) unstable; urgency=medium

  * update to b98b1cd

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 07 Apr 2018 21:03:18 -0400

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: libs
 Priority: optional
 Maintainer: A. Maitland Bottoms <bottoms@debian.org>
-Build-Depends: cmake (>= 2.8),
-               debhelper (>= 9),
-               libiio-dev,
+Build-Depends: cmake,
+               debhelper (>= 12),
+               libiio-dev (>=0.14),
                pkg-config
-Standards-Version: 4.1.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/analogdevicesinc/libad9361-iio
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libad9361.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/libad9361.git
+Vcs-Browser: https://salsa.debian.org/debian/libad9361
+Vcs-Git: https://salsa.debian.org/debian/libad9361.git
 
 Package: libad9361-0
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DINSTALL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
